Package ec.gp.breed

# Class MutatePromotePipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.gp.GPBreedingPipeline
ec.gp.breed.MutatePromotePipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class MutatePromotePipeline extends GPBreedingPipeline
MutatePromotePipeline works very similarly to the PromoteNode algorithm described in Kumar Chellapilla, "A Preliminary Investigation into Evolving Modular Programs without Subtree Crossover", GP98, and is also similar to the "deletion" operator found in Una-May O'Reilly's thesis, "An Analysis of Genetic Programming".

MutatePromotePipeline tries tries times to find a tree that has at least one promotable node. It then picks randomly from all the promotable nodes in the tree, and promotes one. If it cannot find a valid tree in tries times, it gives up and simply copies the individual.

"Promotion" means to take a node n whose parent is m, and replacing the subtree rooted at m with the subtree rooted at n.

A "Promotable" node means a node which is capable of promotion given the existing type constraints. In general to promote a node foo, foo must have a parent node, and must be type-compatible with the child slot that its parent fills.

Typical Number of Individuals Produced Per `produce(...)` call
...as many as the source produces

Number of Sources
1

Parameters

base.`tries` int >= 1 | (number of times to try finding valid pairs of nodes)
base.`tree.0` 0 < int < (num trees in individuals), if exists | (tree chosen for mutation; if parameter doesn't exist, tree is picked at random)

Default Base
gp.breed.mutate-promote

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `NUM_SOURCES`
  `static final String`
  `P_MUTATEPROMOTE`
  `static final String`
  `P_NUM_TRIES`

  ### Fields inherited from class ec.gp.GPBreedingPipeline

  `P_NODESELECTOR, P_TREE, TREE_UNFIXED`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MutatePromotePipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.

  ### Methods inherited from class ec.gp.GPBreedingPipeline

  `produces`

  ### Methods inherited from class ec.BreedingPipeline

  `clone, fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, sourcesAreProperForm, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_MUTATEPROMOTE

    public static final String P_MUTATEPROMOTE
    See Also:
      - Constant Field Values

  - ### P_NUM_TRIES

    public static final String P_NUM_TRIES
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### MutatePromotePipeline

    public MutatePromotePipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`